#include <io8252.h>
#include "lcd.h"
#include "chast.h"
#include "time.h"
#include "eeprom.h"
#include "keyb.h"
#include "init.h"

#define FreqProc 12000000 /* */
#define FInt 50 /* 뢠*/
#define FClock 1000000 /* */
#define T0H (65536 - (FreqProc / 12 / FInt)) >> 8
#define T0L (65536 - (FreqProc / 12 / FInt)) & 0xff
#define R2H (65536 - (FreqProc / 4 / FClock)) >> 8
#define R2L (65536 - (FreqProc / 4 / FClock)) & 0xff
#define SpeedCom(Speed) (256 - (char)((double)FreqProc / 12.0 / 16.0 / ((double)Speed) + 0.5))
#define Freq(freq) (65535 - (unsigned int)((double)FreqProc / 12.0 / ((int)freq))

#define START P3.7

data unsigned char Timer2, rgm, IE18, T2Int, T2Max;
data unsigned char i1, i2, rgmAlarm;
data unsigned long Period, Chastota, Prom, Prom1, Rez;
data unsigned long Save;
data unsigned long Zn;

data char Ch[10];
data unsigned char Key[16];

data union uLONGS
{
    struct
    {
        unsigned char b0;
        unsigned char b1;
        unsigned char b2;
        unsigned char b3;
    } BYTES;
    unsigned long LONG;
    unsigned int INT;
} CH;

interrupt [0x2B] void T2_int (void)      /* Timer 2 Overflow */
{
    if (fChas) P1.0 ^= 1;
    else
    {
        T2Int++;
        if (T2Int > T2Max)
        {
            P1.0 ^= 1;
            T2Int = 0;
        }
    }
    T2CON &= 0x7f;
}

interrupt [0x03] void EX0_int (void)     /* External Interrupt 0 */
{
    fEO = 1;
}

interrupt [0x1B] void T1_int (void)
{
    if (rgm == Per) CH.INT++;
    else
    if ( (rgm == Frq) || (rgm == Sum) ) CH.BYTES.b0++;
    else
    if (fAlarm && Vrema.4)
    {
        TH1 = 0xfe;
        TL1 = 0x0b;
        P1.2 ^= 1;
    }
}

interrupt [0x13] void EX1_int (void)     /* External Interrupt 1 */
{
    CH.BYTES.b3 = TL1;
    CH.BYTES.b2 = TH1;
    Period = CH.LONG;
    TH1 = 0;
    TL1 = 0;
    CH.BYTES.b0 = 0;
    CH.BYTES.b1 = 0;
}

interrupt [0x0B] void T0_int (void)      /* Timer 0 Overflow */
{
    data char t;
    TH0 = 177;
    TL0 = 240;/*240*/
    if (Timer2 > 49)
    {
        if (fIzmCh == 1)
        {
            if (rgm == Frq)
            {
                if (FreqRgm == 0)/*७ 1 ᥪ*/
                {
                    t = 8;
                    while (--t) {};
                    ACC;
                    ACC;
                    ACC;
                    ACC;
                    ACC;
                }
                else  /*७ 0,1 ᥪ*/
                {
                    t = 1;
                    while (--t) {};
                    ACC;
                    ACC;
                    ACC;
                    ACC;
                }
                START = 0;
                TR1 = 0;
                CH.BYTES.b3 = P2;
                CH.BYTES.b2 = TL1;
                CH.BYTES.b1 = TH1;
                Chastota = CH.LONG;
                Timer2 = 45;
                fEO = 1;
                fIzmCh = 0;
            }
        }
        else
        {
            if (rgm == Frq)
            {
                CH.BYTES.b0 = 0;
                TL1 = 0;
                TH1 = 0;
                TR1 = 1;
                START = 1;
                if (FreqRgm == 0) Timer2 = 0;
                else  Timer2 = 45;
                fIzmCh = 1;
            }
        }
        if (rgm == Per)
        {
            Timer2 = 0;
            fEO = 1;
        }
    }
    Timer2++;
    Vrema++;

    if (rgm == Sum)
    {
        CH.BYTES.b3 = P2;
        CH.BYTES.b2 = TL1;
        CH.BYTES.b1 = TH1;
        Chastota = CH.LONG;
        fEO = 1;
    }

    B = P0;
    P0 = B | 0xf0;

    P1.7 = 0;
    if (!P0.7)
    {
        Key[0]++;
        if (Key[0] == 5) Kla1.0 = 1;  /* 0 */
        if (Key[0] > 50)
        {
            Key[0] = 40;
            Kla1.0 = 1;
        }
    }
    else Key[0] = 0;
    if (!P0.6)
    {
        Key[1]++;
        if (Key[1] == 5) Kla1.1 = 1;  /* 1 */
        if (Key[1] > 50)
        {
            Key[1] = 40;
            Kla1.1 = 1;
        }
    }
    else Key[1] = 0;
    if (!P0.5)
    {
        Key[2]++;
        if (Key[2] == 5) Kla1.2 = 1;  /* 4 */
        if (Key[2] > 50)
        {
            Key[2] = 40;
            Kla1.2 = 1;
        }
    }
    else Key[2] = 0;
    if (!P0.4)
    {
        Key[3]++;
        if (Key[3] == 5) Kla1.3 = 1;  /* 7 */
        if (Key[3] > 50)
        {
            Key[3] = 40;
            Kla1.3 = 1;
        }
    }
    else Key[3] = 0;
    P1.7 = 1;

    P1.6 = 0;
    if (!P0.7)
    {
        Key[4]++;
        if (Key[4] == 5) Kla1.4 = 1;   
        if (Key[4] > 20) Key[4] = 20;
    }
    else Key[4] = 0;
    if (!P0.6)
    {
        Key[5]++;
        if (Key[5] == 5) Kla1.5 = 1;   /* 2 */
        if (Key[5] > 50)
        {
            Key[5] = 40;
            Kla1.5 = 1;
        }
    }                                         
    else Key[5] = 0;                          
    if (!P0.5)                                
    {                                         
        Key[6]++;                             
        if (Key[6] == 5) Kla1.6 = 1;   /* 5 */
        if (Key[6] > 50)
        {
            Key[6] = 40;
            Kla1.6 = 1;
        }
    }                                         
    else Key[6] = 0;                          
    if (!P0.4)                                
    {                                         
        Key[7]++;                             
        if (Key[7] == 5) Kla1.7 = 1;   /* 8 */
        if (Key[7] > 50)
        {
            Key[7] = 40;
            Kla1.7 = 1;
        }
    }
    else Key[7] = 0;
    P1.6 = 1;

    P1.5 = 0;
    if (!P0.7)
    {
        Key[8]++;
        if (Key[8] == 5) Kla2.0 = 1;
        if (Key[8] > 20) Key[8] = 20;
    }
    else Key[8] = 0;
    if (!P0.6)
    {
        Key[9]++;
        if (Key[9] == 5) Kla2.1 = 1;    /* 3 */
        if (Key[9] > 50)
        {
            Key[9] = 40;
            Kla2.1 = 1;
        }
    }
    else Key[9] = 0;
    if (!P0.5)
    {
        Key[10]++;
        if (Key[10] == 5) Kla2.2 = 1;   /* 6 */
        if (Key[10] > 50)
        {
            Key[10] = 40;
            Kla2.2 = 1;
        }
    }
    else Key[10] = 0;
    if (!P0.4)
    {
        Key[11]++;
        if (Key[11] == 5) Kla2.3 = 1;  /* 9 */
        if (Key[11] > 50)
        {
            Key[11] = 40;
            Kla2.3 = 1;
        }
    }
    else Key[11] = 0;
    P1.5 = 1;

    P1.4 = 0;
    if (!P0.7)
    {
        Key[12]++;
        if (Key[12] == 5) Kla2.4 = 1;
        if (Key[12] > 20) Key[12] = 20;
    }
    else Key[12] = 0;
    if (!P0.6)
    {
        Key[13]++;
        if (Key[13] == 5) Kla2.5 = 1;
        if (Key[13] > 20) Key[13] = 20;
    }
    else Key[13] = 0;
    if (!P0.5)
    {
        Key[14]++;
        if (Key[14] == 5) Kla2.6 = 1;
        if (Key[14] > 20) Key[14] = 20;
    }
    else Key[14] = 0;
    if (!P0.4)
    {
        Key[15]++;
        if (Key[15] == 5) Kla2.7 = 1;
        if (Key[15] > 20) Key[15] = 20;
    }
    else Key[15] = 0;
    P1.4 = 1;

    P0 = B;
}

void Delenie (unsigned long d1)
{
    Prom = d1 / 10;
    Ch[0] = R3;
    Prom1 = Prom / 10;
    Ch[1] = R3;
    Prom = Prom1 / 10;
    Ch[2] = R3;
    Prom1 = Prom / 10;
    Ch[3] = R3;
    Prom = Prom1 / 10;
    Ch[4] = R3;
    Prom1 = Prom / 10;
    Ch[5] = R3;
    Prom = Prom1 / 10;
    Ch[6] = R3;
    Prom1 = Prom / 10;
    Ch[7] = R3;
    Prom = Prom1 / 10;
    Ch[8] = R3;
}

void main(void)
{
    InitCom ();
    InitLCD();                     
    START = 0;
    P1.1 = 0;

    CH.BYTES.b0 = eepromRD (0x10);
    CH.BYTES.b1 = eepromRD (0x11);
    CH.BYTES.b2 = eepromRD (0x12);
    CH.BYTES.b3 = eepromRD (0x13);
    Zn = CH.LONG;
    if (Zn > 3000000)
    {
        Zn = 0;
        rgm = Time;
    }
    Gener();

    WrD8583(0x3f,0xa5);
    if (Rd8583(0x3f) == 0xa5) 
    {
        InitTime ();
        fPresTime = 1;
    } else fPresTime = 0;

    rgm = eepromRD(0);
    if (!fPresTime) if (rgm > 3) rgm = 0;
    if (rgm > rgmMax) rgm = 0;


    fIzmRgm = 1;

    while (1)
    {
        do
        {
            PCON |= 0x01;
            WMCON |= 0xe3;   /*11100011*/
            Keyb();
        } while (!fEO);
        {
            if (rgm == Frq)
            {
                Chastota-= IE18;
                IE18 = P2;
                if (FreqRgm == 1)
                {
                    Chastota *= 10;
                    Save = Chastota;
                    Delenie (Chastota);
                    OutLCD (0x02, ' ', ' ');
                    wrlcd (0x0c, '*');
                }
                else
                {
                    Save = Chastota;
                    Delenie (Chastota);
                    OutLCD (0x02, ' ', ' ');
                }
                if (Chastota == 0) Print (0x40, "                ");
                else
                {
                    Period = 1000000000 / Chastota;
                    if (Period > 999999999)
                    {
                        Period /= 1000;
                        Print (0x4d," uS");
                    }
                    else Print (0x4d," nS");
                    Delenie (Period);
                    OutLCD (0x42, ' ', ' ');
                    wrlcd (0x40,'P');
                }
            }
            else if (rgm == Per)
            {
                Rez = Period;
                Delenie (Rez);
                OutLCD (0x42, ' ', ' ');
                if (Rez != 0)
                {
                    Prom = 1000000000 / Rez;
                    Delenie (Prom);
                    OutLCD (0x02, ' ', '.');
                    Print (0x00,"F");
                    Print (0x0d," Hz");
                }
                else Print (0x00,"                ");
            }
            else if (rgm == Gen)
            {
                Delenie (Zn);
                OutLCD (0x02, ' ', ' ');
                Prom = 3000000 / Zn;
                if (Prom < 4)
                {
                    Prom1 = 3000000 / Prom;
                    Delenie (Prom1);
                    OutLCD (0x42, ' ', ' ');
                }
                else
                {
                    Prom1 = 3000000000 / Prom;
                    Delenie (Prom1);
                    OutLCD (0x42, ' ', '.');
                }
            }
            else if (rgm == Sum)
            {
                Chastota -= IE18;
                Delenie (Chastota);
                OutLCD (0x02, ' ', ' ');
            }
            else if (rgm == Time) OutTime();
            else if (rgm == Alarm) OutAlarm ();
            fEO = 0;
        }
    }
}