#include <io8252.h>
#include "lcd.h"
#include "chast.h"

#define RS P0.0
#define RW P0.1
#define E P0.2

code char ConvSym1[] ={0x41,0xa0,0x42,0xa1,0xe0,0x45,0xa3,0xa4,0xa5,0xa6,
                       0x4b,0xa7,0x4d,0x48,0x4f,0xa8,0x50,0x43,0x54,0xa9,
                       0xaa,0x58,0xe1,0xab,0xac,0xe2,0xad,0xae,0x62,0xaf,
                       0xb0,0xb1,0x61,0xb2,0xb3,0xb4,0xe3,0x65,0xb6,0xb7,
                       0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0x6f,0xbe};
code char ConvSym2[] ={0x70,0x63,0xbf,0x79,0xe4,0x78,0xe5,0xc0,0xc1,0xe6,
                       0xc2,0xc3,0xc4,0xc5,0xc6,0xc7};

extern data char Ch[10];

void Pausa1 (void)
{
    char paus;
    paus = 9;
    while (--paus);
}

void Pausa (void)
{
    char paus1, paus2;
    for (paus1 = 0; paus1 < 40; paus1++)
    {
        paus2 = 10;
        while (--paus2);
    }
}

void InitLCD (void)
{
    P0 = 0;
    E = 1;
    P0 = 0x24;
    E = 0;
    Pausa();

    P0 = 0;
    E = 1;
    P0 = 0x04;
    E = 0;
    E = 1;
    P0 = 0x14;
    E = 0;
    Pausa();

    P0 = 0;
    E = 1;
    P0 = 0x04;
    E = 0;
    E = 1;
    P0 = 0x24;
    E = 0;
    Pausa();

    P0 = 0;
    E = 1;
    P0 = 0x04;
    E = 0;
    E = 1;
    P0 = 0x33;
    E = 0;
    Pausa();

    P0 = 0;
    E = 1;
    P0 = 0x24;
    E = 0;
    E = 1;
    P0 = 0x84;
    E = 0;
    Pausa();

    P0 = 0;
    E = 1;
    P0 = 0x04;
    E = 0;
    E = 1;
    P0 = 0xc4;
    E = 0;
    Pausa();
}

void wrlcd (unsigned char addr, unsigned char d)
{
    P0 = 0;
    E = 1;
    B = addr | 0x80;
    P0.7 = B.7;
    P0.6 = B.6;
    P0.5 = B.5;
    P0.4 = B.4;
    E = 0;
    E = 1;
    P0.7 = B.3;
    P0.6 = B.2;
    P0.5 = B.1;
    P0.4 = B.0;
    E = 0;
    Pausa1();
    P0 = 0x01;
    E = 1;
    B = d;
    P0.7 = B.7;
    P0.6 = B.6;
    P0.5 = B.5;
    P0.4 = B.4;
    E = 0;
    E = 1;
    P0.7 = B.3;
    P0.6 = B.2;
    P0.5 = B.1;
    P0.4 = B.0;
    E = 0;
    Pausa1();
}

void Print (char p, char *St)
{
    data unsigned char i, i5;
    for (i = 0; ((i5 = St[i]) != '\0'); i++)
    {
        if (i5 < 0x80) wrlcd (p+i,i5);
        else if (i5 < 0xb0) wrlcd (p+i,ConvSym1[i5-0x80]);
             else wrlcd (p+i,ConvSym2[i5-0xe0]);   
    }
}

void OutLCD (data char o1, char o2, char o3)
{
    fNull = 0;
    wrlcd (o1+3, ' ');
    wrlcd (o1+7, ' ');
    if (Ch[8] == 0) wrlcd (o1, ' ');
    else
    {
        wrlcd (o1, Ch[8]+'0');
        fNull = 1;
    }
    if ((Ch[7] == 0) && (fNull == 0)) wrlcd (++o1, ' ');
    else
    {
        wrlcd (++o1, Ch[7]+'0');
        fNull = 1;
    }
    if ((Ch[6] == 0) && (fNull == 0)) { wrlcd (++o1, ' '); o1++; }
    else
    {
        wrlcd (++o1, Ch[6]+'0');
        wrlcd (++o1, o2);
        fNull = 1;
    }
    if ((Ch[5] == 0) && (fNull == 0)) wrlcd (++o1, ' ');
    else
    {
        wrlcd (++o1, Ch[5]+'0');
        fNull = 1;
    }
    if ((Ch[4] == 0) && (fNull == 0)) wrlcd (++o1, ' ');
    else
    {
        wrlcd (++o1, Ch[4]+'0');
        fNull = 1;
    }
    if ((o3 == ' ') && (Ch[3] == 0) && (fNull == 0)) { wrlcd (++o1, ' '); o1++; } 
    else
    {
        wrlcd (++o1, Ch[3]+'0');
        wrlcd (++o1, o3);
        fNull = 1;
    }
    if ((Ch[2] == 0) && (fNull == 0)) wrlcd (++o1, ' '); 
    else
    {
        wrlcd (++o1, Ch[2]+'0');
        fNull = 1;
    }
    if ((Ch[1] == 0) && (fNull == 0)) wrlcd (++o1, ' ');
    else
    {
        wrlcd (++o1, Ch[1]+'0');
        fNull = 1;
    }
    wrlcd (++o1, Ch[0]+'0');
}

