#include "time.h"
#include "chast.h"
#include "lcd.h"
#include "eeprom.h"

extern char i1, rgmAlarm;
extern data char Ch[10];

void Del(void)
{
}

void Start8583(void)
{
    SDA = 1;
    SCL = 1;
    Del();
    SDA = 0;
    Del();
    SCL = 0;
}

void Stop8583(void)
{
    SDA = 0;
    Del();
    SCL = 1;
    Del();
    SDA = 1;
    Del();
}

void Wr8583 (unsigned char i)
{
    B = i;
    SDA = B.7;
    SCL = 1;
    Del();
    SCL = 0;
    Del();
    SDA = B.6;
    SCL = 1;
    Del();
    SCL = 0;
    Del();
    SDA = B.5;
    SCL = 1;
    Del();
    SCL = 0;
    Del();
    SDA = B.4;
    SCL = 1;
    Del();
    SCL = 0;
    Del();
    SDA = B.3;
    SCL = 1;
    Del();
    SCL = 0;
    Del();
    SDA = B.2;
    SCL = 1;
    Del();
    SCL = 0;
    Del();
    SDA = B.1;
    SCL = 1;
    Del();
    SCL = 0;
    Del();
    SDA = B.0;
    SCL = 1;
    Del();
    SCL = 0;
    Del();

    SDA = 1;
    Del();
    SCL = 1;
    Del();
    SCL = 0;
}

unsigned char Rd8583(unsigned char i)
{
    Start8583();
    Wr8583(slaveWR);
    Wr8583(i);
    Start8583();
    Wr8583(slaveRD);
    SCL = 1;
    Del();
    B.7 = SDA;
    SCL = 0;
    Del();
    SCL = 1;
    Del();
    B.6 = SDA;
    SCL = 0;
    Del();
    SCL = 1;
    Del();
    B.5 = SDA;
    SCL = 0;
    Del();
    SCL = 1;
    Del();
    B.4 = SDA;
    SCL = 0;
    Del();
    SCL = 1;
    Del();
    B.3 = SDA;
    SCL = 0;
    Del();
    SCL = 1;
    Del();
    B.2 = SDA;
    SCL = 0;
    Del();
    SCL = 1;
    Del();
    B.1 = SDA;
    SCL = 0;
    Del();
    SCL = 1;
    Del();
    B.0 = SDA;
    SCL = 0;
    Del();

    SCL = 1;
    Del();
    SCL = 0;
    Stop8583();
    return(B);
}

void InitTime (void)
{
    if (Rd8583 (control) != 0x10) WrD8583(control,0x10);
    Bud = Rd8583(hours);
    if ((Bud & 0xc0) != 0) WrD8583(hours,Bud&0x3f);
    Bud = Rd8583(seconds);
    if (Bud.7 == 1) WrD8583(seconds,i1&0x7f);
}

void OutTime(void)
{
    Ch[0] = Rd8583(hours);
    Ch[1] = Rd8583(minutes);
    Ch[2] = Rd8583(seconds);
    Ch[3] = Rd8583(day);
    Ch[4] = Rd8583(date);
    Ch[5] = Rd8583(month);
    Ch[6] = Rd8583(year);

    if (Ch[2] == 2) P1.1 = 0;

    Ch[9] = Ch[0] / 16;
    Ch[8] = Ch[0] & 0x0f;
    if (Ch[9] != 0) wrlcd (0x00, Ch[9]+'0');
    else wrlcd (0x00, ' ');
    wrlcd (0x01, Ch[8]+'0');
    wrlcd (0x02, ':');

    Ch[9] = Ch[1] / 16;
    Ch[8] = Ch[1] & 0x0f;
    wrlcd (0x03, Ch[9]+'0');
    wrlcd (0x04, Ch[8]+'0');
    wrlcd (0x05, ':');

    Ch[9] = Ch[2] / 16;
    Ch[8] = Ch[2] & 0x0f;
    wrlcd (0x06, Ch[9]+'0');
    wrlcd (0x07, Ch[8]+'0');

    if (Ch[3] == 1)      Print (0x08, "  .");
    else if (Ch[3] == 2) Print (0x08, " ୨");
    else if (Ch[3] == 3) Print (0x08, "   ।");
    else if (Ch[3] == 4) Print (0x08, " ⢥");
    else if (Ch[3] == 5) Print (0x08, " ⭨");
    else if (Ch[3] == 6) Print (0x08, " 㡡");
    else if (Ch[3] == 7) Print (0x08, "  .");

    Ch[9] = Ch[4] / 16;
    Ch[8] = Ch[4] & 0x0f;
    if (Ch[9] != 0) wrlcd (0x40, Ch[9]+'0');
    else wrlcd (0x40, ' ');
    wrlcd (0x41, Ch[8]+'0');

    if (Ch[5] == 0x01)      Print (0x42, "   20  ");
    else if (Ch[5] == 0x02) Print (0x42, " ࠫ 20  ");
    else if (Ch[5] == 0x03) Print (0x42, "    20  ");
    else if (Ch[5] == 0x04) Print (0x42, " ५  20  ");
    else if (Ch[5] == 0x05) Print (0x42, "      20  ");
    else if (Ch[5] == 0x06) Print (0x42, "     20  ");
    else if (Ch[5] == 0x07) Print (0x42, "     20  ");
    else if (Ch[5] == 0x08) Print (0x42, "  20  ");
    else if (Ch[5] == 0x09) Print (0x42, " . 20  ");
    else if (Ch[5] == 0x10) Print (0x42, "  20  ");
    else if (Ch[5] == 0x11) Print (0x42, "   20  ");
    else if (Ch[5] == 0x12) Print (0x42, "  20  ");

    Ch[9] = Ch[6] / 16;
    Ch[8] = Ch[6] & 0x0f;
    wrlcd (0x4d, Ch[9]+'0');
    wrlcd (0x4e, Ch[8]+'0');

    Ch[4] = ((Ch[0] / 16) * 10) + (Ch[0] & 0x0f); /**/
    Ch[5] = ((Ch[1] / 16) * 10) + (Ch[1] & 0x0f); /**/
    Ch[6] = 1 << (Ch[3]);
    if (Ch[2] == 0)
    {
        if ( (Budilnik(0)  == 1) ||
             (Budilnik(3)  == 1) ||
             (Budilnik(6)  == 1) ||
             (Budilnik(9)  == 1) ||
             (Budilnik(12) == 1) )
        {
            fAlarm = 1;
            P1.1 = 1;
            TMOD = 0x11;
            EX1 = 0;
            ET1 = 1;
            TR1 = 1;
            TH1 = 0xfe;
            TL1 = 0x0b;
            IP = 0x08;
        }
        else
        {
            fAlarm = 0;
            TR1 = 0;
            ET1 = 0;
            IP = 0x2f;
        }
    }
}

char Budilnik (data unsigned char Bud) /*஢ઠ  ࠡ뢠 㤨쭨*/
{
    if  ( ( (Rd8583(0x20+Bud) == Ch[4]) || (Rd8583(0x20+Bud) == 24) ) /**/
       && (Rd8583(0x21+Bud) == Ch[5])    /**/
       && (Rd8583(0x22+Bud) &  Ch[6]) )  /*ᥪ㭤*/
       return (1);
    else return (0);
}

void OutAlarm (void)
{ 
    wrlcd (0x09, rgmAlarm+'1');

    Ch[0] = Rd8583(0x20+(rgmAlarm*3)); /**/
    Ch[1] = Rd8583(0x21+(rgmAlarm*3)); /**/
    Bud = Rd8583(0x22+(rgmAlarm*3));   /* */

    Ch[9] = Ch[0] / 10;
    Ch[8] = B;
    if (Ch[9] != 0) wrlcd (0x0b, Ch[9]+'0');
    else wrlcd (0x0b, ' ');
    wrlcd (0x0c, Ch[8]+'0');
    wrlcd (0x0d, ':');

    Ch[9] = Ch[1] / 10;
    Ch[8] = B;
    wrlcd (0x0e, Ch[9]+'0');
    wrlcd (0x0f, Ch[8]+'0');

    Print(0x40,"                ");
    if (Bud.1) Print(0x41,"");
    if (Bud.2) Print(0x43,"");
    if (Bud.3) Print(0x45,"");
    if (Bud.4) Print(0x47,"");
    if (Bud.5) Print(0x49,"");
    if (Bud.6) Print(0x4b,"");
    if (Bud.7) Print(0x4d,"");
} 

void WrD8583 (idata char addr, idata char dat)
{
    Start8583();
    Wr8583(slaveWR);
    Wr8583(addr);
    Wr8583(dat);
    Stop8583();
}
